#!/usr/bin/perl

#############################################################################
#
# This script extracts the minimal selection of source files in the current
# directory necessary to compile the .cpp programs.
#
#############################################################################

# Copyright (C) 1997-2014 by Pawel Pilarczyk.
#
# This file is part of my research software package. This is free software:
# you can redistribute it and/or modify it under the terms of the GNU
# General Public License as published by the Free Software Foundation,
# either version 3 of the License, or (at your option) any later version.
#
# This software is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this software; see the file "license.txt". If not,
# please, see <https://www.gnu.org/licenses/>.

# Started on September 15, 2010. Last revision: September 15, 2010.


# create the list of files to scan
my @files = scalar (@ARGV) ? @ARGV : glob ('*.cpp');

# prepare a list of indices of the files in the array
my %files = {};
for (my $i = 0; $i < scalar (@files); ++ $i)
{
	$files{$files[$i]} = $i;
}

# scan the files and extend the array
for (my $i = 0; $i < scalar (@files); ++ $i)
{
	my $filename = $files[$i];
	open (FILE, "<$filename") or die "Can't open $filename";
#	print "Analysing '$filename'...\n";
	while (<FILE>)
	{
		m/^\s*\#\s*include\s*"([^\/"]+)"/ or next;
		my $included = $1;
	#	print " - $included\n";
		next if defined ($files{$included});
		$files{$included} = scalar (@files);
		push (@files, $included);
	}
	close (FILE);
}

my $zipcmd = "zip -9 -u selection makefile* license.txt " . join (' ', @files);
#print "$zipcmd\n";
print `$zipcmd`;

